import math
###############################################################################
# 3XvC֐Ő`̃X[YsXNvg
# g
# EShade3DscriptstH_[ɓShade3DN
# EW̃X[YƓlɑΏۂIăXNvgj[Ăяo܂B
# E`ҏW[hƕIɃX[Yo܂B
# EΏۂĂȂꍇ̓j[\[_wł܂B
# ERłȂꍇ͊̃nhێ܂B
# E͎n_ƏI_qĂ悤Ɉ܂B(͖)
# ERȖʂIĂꍇ͌ݐ؂芷Ă̑SĂ
#   `ɓKp܂B
# Eׂ荇_dȂĂiOjꍇłX[Yo܂B
# ӎ
# EUNDOoȂ̂ŎsOɌ`̃Rs[ĂłB
# EShade3D ver.18œmF
# Copyright 2020 by Arimac.
###############################################################################

###############################################################################
# 3XvC֐
# 
#  start_cd : n_(1=R, 2=Œ, 3=)
#  end_cd   : I_(1=R, 2=Œ, 3=)
#  woh : n_nh([hW)
#  wih : I_nh([hW)
#  an_vec : Wlz
# ߂l
#  ret : 0=, -1:ُ
#  po_idx : dW_Wlz̃CfbNX
#  f2 : 3Ȑ̌Wz
#  f3 : 3Ȑ̌Wz
#  f4 : 3Ȑ̌Wz
# Ql
#  Rs[^OtBbNX(DAVID F.ROGERS, J.ALAN ADAMS, Rxmv)
###############################################################################
def calc_spline(start_cd, end_cd, woh, wih, an_vec):
    """3XvC֐"""

    f2 = []
    f3 = []
    f4 = []

    an_dif, an_dis, po_idx = calc_dist(an_vec)
    if len(an_dis) < 1:
        return -1, po_idx, f2, f3, f4

    if start_cd == 3:   # 
        u = calc_cyclic(an_dif, an_dis)
    else:
        u = calc_nocyclic(start_cd, end_cd, woh, wih, an_vec, an_dif, an_dis)

    f2, f3, f4 = gen_parm(an_dif, an_dis, u)

    return 0, po_idx, f2, f3, f4

###############################################################################
# eWԂ̋߂
# 
#  an_vec : Wlz
# ߂l
#  an_dif : W̔z
#  an_dis : WԂ̋̔z
#  po_idx : dW_Wlz̃CfbNX
###############################################################################
def calc_dist(an_vec):
    """eWԂ̋߂"""

    dim = len(an_vec[0])
    an_cnt = len(an_vec)
    an_dif = []
    an_dis = []
    po_idx = [0] * an_cnt
    l = 0
    i = 0

    for j in xrange(1, an_cnt):
        v0 = an_vec[l]
        v1 = an_vec[j]
        d1 = 0.0
        dif = [0.0] * dim
        for k in xrange(dim):
            d2 = v1[k] - v0[k]
            dif[k] = d2
            d1 += d2 * d2
        if d1 >= 0.000001:
            an_dif.append(dif)
            an_dis.append(math.sqrt(d1))
            i += 1
            l = j
        po_idx[j] = i

    return an_dif, an_dis, po_idx

###############################################################################
# XvČvZ
# 
#  an_dif : W̔z
#  an_dis : WԂ̋̔z
# ߂l
#  u : ^WFgxN^[z
###############################################################################
def calc_cyclic(an_dif, an_dis):
    """XvČvZ"""

    an_cnt2 = len(an_dis)
    dim = len(an_dif[0])
    m = [[0.0] * an_cnt2 for i in xrange(an_cnt2)]
    c = [0.0] * an_cnt2
    b = [[0.0] * dim for i in xrange(an_cnt2)]

    d1 = an_dis[an_cnt2 - 1] / an_dis[0]
    m[0][0] = d1 * 2.0 + 2.0
    m[0][1] = d1
    m[0][an_cnt2 - 1] = 1.0
    d2 = 3.0 / an_dis[0]
    for k in xrange(dim):
        b[0][k] = (an_dif[0][k] * d1 + an_dif[an_cnt2 - 1][k] / d1) * d2

    for j in xrange(1, an_cnt2 - 1):
        m[j][j - 1] = an_dis[j]
        m[j][j] = (an_dis[j] + an_dis[j - 1]) * 2.0
        m[j][j + 1] = an_dis[j - 1]

    j = an_cnt2 - 1
    m[j][j - 1] = an_dis[j]
    m[j][j] = (an_dis[j] + an_dis[j - 1]) * 2.0
    m[j][0] = an_dis[j - 1]

    for j in xrange(1, an_cnt2):
        d1 = 3.0 / (an_dis[j] * an_dis[j - 1])
        d2 = an_dis[j - 1] * an_dis[j - 1]
        d3 = an_dis[j] * an_dis[j]
        for k in xrange(dim):
            b[j][k] = (d2 * an_dif[j][k] + d3 * an_dif[j - 1][k]) * d1

    invert_matrix(m)

    u = [[0.0] * dim for i in xrange(an_cnt2 + 1)]

    for k in xrange(dim):
        for l in xrange(an_cnt2):
            c[l] = b[l][k]
        for j in xrange(an_cnt2):
            d1 = 0.0
            for l in xrange(an_cnt2):
                d1 = m[j][l] * c[l] + d1
            u[j][k] = d1

    for k in xrange(dim):
        u[an_cnt2][k] = u[0][k]

    return u

###############################################################################
# ts
# 
#  m : 2z
# Ql
#  bɂASYT(13)(F)
###############################################################################
def invert_matrix(m):
    """ts"""

    an_cnt2 = len(m)
    for k in xrange(an_cnt2):
        d1 = 1.0 / m[k][k]
        for i in xrange(an_cnt2):
            m[k][i] = m[k][i] * d1
        m[k][k] = d1
        for j in xrange(an_cnt2):
            if j != k:
                d2 = m[j][k]
                for i in xrange(an_cnt2):
                    if i == k:
                        m[j][i] = -d2 * d1
                    else:
                        m[j][i] = m[j][i] - m[k][i] * d2
    return

###############################################################################
# XvČvZ
# 
#  start_cd : n_(1=R, 2=Œ, 3=)
#  end_cd   : I_(1=R, 2=Œ, 3=)
#  woh : n_nh([hW)
#  wih : I_nh([hW)
#  an_vec : Wlz
#  an_dif : W̔z
#  an_dis : WԂ̋̔z
# ߂l
#  u : ^WFgxN^[z
###############################################################################
def calc_nocyclic(start_cd, end_cd, woh, wih, an_vec, an_dif, an_dis):
    """XvČvZ"""

    an_cnt2 = len(an_dis)
    dim = len(an_dif[0])
    n1 = [0.0] * (an_cnt2 + 1)
    n2 = [0.0] * (an_cnt2 + 1)
    n3 = [0.0] * (an_cnt2 + 1)
    b = [[0.0] * dim for i in xrange(an_cnt2 + 1)]

    if start_cd == 1:   # n_FR
        n2[0] = 1.0
        n3[0] = 0.5
        d1 = (3.0 / 2.0) / an_dis[0]
        for k in xrange(dim):
            b[0][k] = an_dif[0][k] * d1
    else:               # n_FŒ
        n2[0] = 1.0
        n3[0] = 0.0
        d1 = 3.0 / an_dis[0]
        for k in xrange(dim):
            b[0][k] = (woh[k] - an_vec[0][k]) * d1

    if end_cd == 1:     # I_FR
        n1[an_cnt2] = 2.0
        n2[an_cnt2] = 4.0
        d1 = 6.0 / an_dis[an_cnt2 - 1]
        for k in xrange(dim):
            b[an_cnt2][k] = an_dif[an_cnt2 - 1][k] * d1
    else:               # I_FŒ
        n1[an_cnt2] = 0.0
        n2[an_cnt2] = 1.0
        d1 = 3.0 / an_dis[an_cnt2 - 1]
        for k in xrange(dim):
            b[an_cnt2][k] = (an_vec[len(an_vec) - 1][k] - wih[k]) * d1

    for j in xrange(1, an_cnt2):
        n1[j] = an_dis[j]
        n2[j] = (an_dis[j] + an_dis[j - 1]) * 2.0
        n3[j] = an_dis[j - 1]
        d1 = 3.0 / (an_dis[j] * an_dis[j - 1])
        d2 = an_dis[j - 1] * an_dis[j - 1]
        d3 = an_dis[j] * an_dis[j]
        for k in xrange(dim):
            b[j][k] = (an_dif[j][k] * d2 + an_dif[j - 1][k] * d3) * d1

    for j in xrange(1, an_cnt2 + 1):
        if n1[j] != 0.0:    # @@@
            d1 = n2[j - 1] / n1[j]
            n1[j] = 0.0
            n2[j] = n2[j] * d1 - n3[j - 1]
            n3[j] = n3[j] * d1
            
            d2 = 1.0 / n2[j]
            n1[j] = n1[j] * d2
            n2[j] = 1.0
            n3[j] = n3[j] * d2
            
            for k in xrange(dim):
                b[j][k] = (b[j][k] * d1 - b[j - 1][k]) * d2

    u = [[0.0] * dim for i in xrange(an_cnt2 + 1)]

    for k in xrange(dim):
        u[an_cnt2][k] = b[an_cnt2][k]

    for j in xrange(an_cnt2 - 1, -1, -1):
        for k in xrange(dim):
            u[j][k] = b[j][k] - n3[j] * u[j + 1][k]

    return u

###############################################################################
# 3Ȑ̌W𐶐
# 
#  an_dif : W̔z
#  an_dis : WԂ̋̔z
#  u : ^WFgxN^[z
# ߂l
#  f2 : 3Ȑ̌Wz
#  f3 : 3Ȑ̌Wz
#  f4 : 3Ȑ̌Wz
###############################################################################
def gen_parm(an_dif, an_dis, u):
    """3Ȑ̌W𐶐"""

    dim = len(an_dif[0])
    an_cnt = len(an_dif)
    f2 = [None] * an_cnt
    f3 = [None] * an_cnt
    f4 = [None] * an_cnt

    for j in xrange(an_cnt):
        f2w = [0.0] * dim
        f3w = [0.0] * dim
        f4w = [0.0] * dim
        for k in xrange(dim):
            f2w[k] = u[j][k] * an_dis[j]
            f3w[k] = an_dif[j][k] * 3.0 - (u[j][k] * 2.0 + u[j + 1][k]) * an_dis[j]
            f4w[k] = an_dif[j][k] * (-2.0) + (u[j][k] + u[j + 1][k]) * an_dis[j]
        f2[j] = f2w
        f3[j] = f3w
        f4[j] = f4w

    return f2, f3, f4

###############################################################################
# xWGȐ̃nhvZ
# 
#  an_vec : Wlz
#  po_idx : dW_Wlz̃CfbNX
#  f2 : 3Ȑ̌Wz
#  f3 : 3Ȑ̌Wz
# ߂l
#  outh : AEgnhz([hW)
#  inh  : Cnhz([hW)
# Ql
#  PIXEL '90/10 CĜ߂̐}w(29) (E)
###############################################################################
def calc_handle(an_vec, po_idx, f2, f3):
    """xWGȐ̃nhvZ"""

    dim = len(an_vec[0])
    an_cnt = len(an_vec)
    outh = [None] * an_cnt
    inh = [None] * an_cnt

    for i in xrange(len(f2)):
        for j in xrange(an_cnt - 1, -1, -1):
            if po_idx[j] == i:
                outhw = [0.0] * dim
                inhw = [0.0] * dim
                for k in xrange(dim):
                    outhw[k] = f2[i][k] / 3.0 + an_vec[j][k]
                    inhw[k] = (f2[i][k] * 2.0 + f3[i][k]) / 3.0 + an_vec[j][k]
                outh[j] = outhw
                inh[j + 1] = inhw
                break;

    j = an_cnt - 1
    if not (outh[0] is None):
        inhw = [0.0] * dim
        for k in xrange(dim):
            inhw[k] = an_vec[0][k] * 2.0 - outh[0][k]
        inh[0] = inhw

    if not (inh[j] is None):
        outhw = [0.0] * dim
        for k in xrange(dim):
            outhw[k] = an_vec[j][k] * 2.0 - inh[j][k]
        outh[j] = outhw

    return outh, inh

###############################################################################
# [JWA[hW̕ϊ
###############################################################################
def get_vec_x_mat(v, m, n=1):
    """[JWA[hW̕ϊ"""

    new_vec = []
    for i in xrange(3):
        new_vec.append(v[0]*m[0][i] + v[1]*m[1][i] + v[2]*m[2][i] + n*m[3][i])
    return new_vec

###############################################################################
# XvCX[Y
# 
#  SSdialog : _CAO
#  shape : VFCv
#  start_vi : n_CfbNX
#  end_vi   : I_CfbNX
#  is_cyclic : ȂTrue
#  is_first_shape : RȖʂ̍ŏ̃VFCvȂTrue
#  is_same_cond : ȑÕ_CAOƓȂTrue
# ߂l
#  ret : 0=, -1:ُ
#  is_same_cond : ȑÕ_CAOƓȂTrue
###############################################################################
def spline_smooth(SSdialog, shape, start_vi, end_vi, is_cyclic, is_first_shape, is_same_cond):
    """XvCX[Y"""

    all_cp_cnt = shape.number_of_control_points
    is_closed = shape.closed

    if start_vi < end_vi:
        cp_cnt1 = end_vi - start_vi + 1
    else:
        cp_cnt1 = all_cp_cnt - (start_vi - end_vi - 1)
    cp_cnt2 = cp_cnt1

    if is_cyclic:
        start_cd = 3    # 
        end_cd = 3      # 
        cp_cnt2 += 1
    else:
        if is_first_shape:
            if not is_same_cond:
                # _CAOŏ
                if not SSdialog.ask():
                    return 1, is_same_cond
        start_cd, end_cd, is_same_cond = SSdialog.get()

    an_vec = []
    cur_vi = start_vi
    for j in xrange(0, cp_cnt2):
        cur_cp = shape.control_point(cur_vi)
        an_vec.append(get_vec_x_mat(cur_cp.position, shape.local_to_world_matrix))
        cur_vi += 1
        if cur_vi >= all_cp_cnt:
            cur_vi = 0

    start_cp = shape.control_point(start_vi)
    oh = start_cp.position
    if start_cd == 2:   # n_FŒ
        if start_cp.has_out_handle:
            oh = start_cp.out_handle
    woh = get_vec_x_mat(oh, shape.local_to_world_matrix)

    end_cp = shape.control_point(end_vi)
    ih = end_cp.position
    if end_cd == 2:     # I_FŒ
        if end_cp.has_in_handle:
            ih = end_cp.in_handle
    wih = get_vec_x_mat(ih, shape.local_to_world_matrix)

    ret, po_idx, f2, f3, f4 = calc_spline(start_cd, end_cd, woh, wih, an_vec)
    if ret == 0:
        # ʂ̔f
        outh, inh = calc_handle(an_vec, po_idx, f2, f3)
        
        if is_cyclic:
            inh[0] = inh[cp_cnt1]
        
        if start_cd != 2:   # ŒȊO
            cur_cp = shape.control_point(start_vi)
            if outh[0] is None:
                cur_cp.remove_out_handle()
            else:
                cur_cp.out_handle = get_vec_x_mat(outh[0], shape.world_to_local_matrix)
            if is_cyclic or (not is_closed and start_vi == 0):
                if inh[0] is None:
                    cur_cp.remove_in_handle()
                else:
                    cur_cp.in_handle = get_vec_x_mat(inh[0], shape.world_to_local_matrix)
                cur_cp.linked = True
            else:
                cur_cp.linked = False
        
        cur_vi = start_vi + 1
        for j in xrange(1, cp_cnt1 - 1):
            if (cur_vi >= all_cp_cnt):
                cur_vi = 0
            cur_cp = shape.control_point(cur_vi)
            if outh[j] is None:
                cur_cp.remove_out_handle()
            else:
                cur_cp.out_handle = get_vec_x_mat(outh[j], shape.world_to_local_matrix)
            if inh[j] is None:
                cur_cp.remove_in_handle()
            else:
                cur_cp.in_handle = get_vec_x_mat(inh[j], shape.world_to_local_matrix)
            cur_cp.linked = True
            cur_vi += 1
        
        if end_cd != 2:     # ŒȊO
            cur_cp = shape.control_point(end_vi)
            j = cp_cnt1 - 1
            if is_cyclic or (not is_closed and end_vi == all_cp_cnt - 1):
                if outh[j] is None:
                    cur_cp.remove_out_handle()
                else:
                    cur_cp.out_handle = get_vec_x_mat(outh[j], shape.world_to_local_matrix)
            if inh[j] is None:
                cur_cp.remove_in_handle()
            else:
                cur_cp.in_handle = get_vec_x_mat(inh[j], shape.world_to_local_matrix)
            
            if is_cyclic or (not is_closed and end_vi == all_cp_cnt - 1):
                cur_cp.linked = True
            else:
                cur_cp.linked = False

    return ret, is_same_cond

###############################################################################
# `̃XvCX[Y
# 
#  SSdialog : _CAO
#  shape : VFCv
#  is_first_shape : RȖʂ̍ŏ̃VFCvȂTrue
#  is_same_cond : ȑÕ_CAOƓȂTrue
# ߂l
#  ret : 0=, -1:ُ
#  is_same_cond : ȑÕ_CAOƓȂTrue
###############################################################################
def line_smooth(SSdialog, shape, is_first_shape, is_same_cond):
    """`̃XvCX[Y"""

    po_cnt = shape.number_of_control_points
    is_closed = shape.closed

    if not Xscene.is_modify_mode:   # ҏW[hłȂH
        return spline_smooth(SSdialog, shape, 0, po_cnt - 1, is_closed, is_first_shape, is_same_cond)

    # IꂽX[Y(ʉߓ_w)
    act_idx = shape.active_vertex_indices
    act_cnt = len(act_idx)
    if act_cnt <= 0:
        xshade.show_message_box('_IĂ܂', False)
        return 0, is_same_cond

    start_vi = end_vi = act_idx[0]

    if is_closed:   # Ă
        if act_cnt == po_cnt:
            return spline_smooth(SSdialog, shape, 0, po_cnt - 1, True, True, is_same_cond)
        j = 1
        if start_vi == 0:
            for i in xrange(1, act_cnt):
                cur_vi = act_idx[i]
                if cur_vi != i:
                    start_vi = end_vi = cur_vi
                    j = i + 1
                    break
            else:
                j = 1
        start_vi -= 1
        if start_vi < 0:
            start_vi = po_cnt - 1
        end_vi += 1
        if end_vi >= po_cnt:
            end_vi = 0
        for i in xrange(1, act_cnt):
            if j >= act_cnt:
                j = 0
            cur_vi = act_idx[j]
            j += 1
            if cur_vi != end_vi:
                ret, is_same_cond = spline_smooth(SSdialog, shape, start_vi, end_vi, False, True, is_same_cond)
                if ret != 0:
                    return ret, is_same_cond
                start_vi = cur_vi - 1
                if start_vi < 0:
                    start_vi = po_cnt - 1
            end_vi = cur_vi + 1
            if end_vi >= po_cnt:
                end_vi = 0
        return spline_smooth(SSdialog, shape, start_vi, end_vi, False, True, is_same_cond)

    # JĂ
    for i in xrange(1, act_cnt):
        cur_vi = act_idx[i]
        if cur_vi != end_vi + 1:
            if start_vi > 0:
                start_vi -= 1
            if end_vi < po_cnt - 1:
                end_vi += 1
            ret, is_same_cond = spline_smooth(SSdialog, shape, start_vi, end_vi, False, True, is_same_cond)
            if ret != 0:
                return ret, is_same_cond
            start_vi = cur_vi
        end_vi = cur_vi
    if start_vi > 0:
        start_vi -= 1
    if end_vi < po_cnt - 1:
        end_vi += 1
    return spline_smooth(SSdialog, shape, start_vi, end_vi, False, True, is_same_cond)

###############################################################################
# `FbN{bNX쐬
###############################################################################
def make_bool(dialog, caption, value):
    """`FbN{bNX쐬"""

    bool_index = dialog.append_bool(caption)
    dialog.set_value(bool_index, value)
    dialog.set_default_value(bool_index, value)
    return bool_index

###############################################################################
# _CAOݒ ##############################################################
###############################################################################
class SplineSettingDialog:
    """XvCX[Y _CAOݒ"""

    def __init__(self):
        """RXgN^"""
        self.Xdialog = xshade.create_dialog()#dialog̃CX^X
        self.start_index = make_bool(self.Xdialog, 'n_FR', False)
        self.end_index = make_bool(self.Xdialog, 'I_FR', False)
        self.cyclic_index = make_bool(self.Xdialog, 'ȉDj', False)
        self.same_index = make_bool(self.Xdialog, 'ȍ~͓', False)

    def ask(self):
        """͑҂"""
        return self.Xdialog.ask('XvCX[Y')

    def get(self):
        """f[^"""
        is_same_cond = self.Xdialog.get_value(self.same_index)
        start_cd = 1 if self.Xdialog.get_value(self.start_index) else 2     # 1FRA2FŒ
        end_cd = 1 if self.Xdialog.get_value(self.end_index) else 2         # 1FRA2FŒ
        if self.Xdialog.get_value(self.cyclic_index):
            start_cd = 3    # 
            end_cd = 3      # 
        return start_cd, end_cd, is_same_cond

###############################################################################
# C ##################################################################
###############################################################################
SSdialog = SplineSettingDialog()
Xscene = xshade.scene()

# xshade.shade().message_window_shown = 1       # NɃbZ[WEChEJ

is_same_cond = False
for Xshape in Xscene.active_shapes:
    # print '(' + Xshape.name + ')'
    if Xshape.type == 2:    # p[g
        if Xshape.part_type == 0:   # p[g
            # print 'p[g'
            pass
        elif Xshape.part_type == 1:     # RȖ
            # print 'RȖ'
            is_first_shape = True
            shape = Xshape.son
            while shape.has_bro:
                shape = shape.bro
                # print '(' + shape.name + ')'
                ret, is_same_cond = line_smooth(SSdialog, shape, is_first_shape, is_same_cond)
                if ret != 0:
                    break
                is_first_shape = False
        else:
            # print '̑ part_type = ' + str(Xshape.part_type)
            pass
    elif Xshape.type == 4:  # `
        # print '`'
        ret, is_same_cond = line_smooth(SSdialog, Xshape, True, is_same_cond)
        if ret != 0:
            pass
    else:
        # print '̑ Xshape.type = ' + str(Xshape.type)
        pass
